package top.zhongmingmao.blog.authorizationserver.api;

import org.springframework.http.ResponseEntity;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.User;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class UserController {

  @GetMapping("/api/userInfo")
  public ResponseEntity<UserInfo> getUser() {
    // org.springframework.security.core.userdetails.User implements
    // org.springframework.security.core.userdetails.UserDetails
    User user = (User) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
    return ResponseEntity.ok(
        UserInfo.builder()
            .name(user.getUsername())
            .email(String.join("@", user.getUsername(), "gmail.com"))
            .build());
  }
}
