package top.zhongmingmao.blog.clientapp.oauth2;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.experimental.FieldDefaults;
import org.springframework.http.HttpMethod;
import org.springframework.http.RequestEntity;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.net.URI;

import static top.zhongmingmao.blog.clientapp.oauth2.AuthorizationCodeFlowUtils.*;

@Service
@AllArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE)
public class AuthorizationCodeTokenService {

  public OAuth2Token exchange(final String code) {
    RestTemplate rest = new RestTemplate();
    RequestEntity<MultiValueMap<String, String>> request =
        new RequestEntity<>(
            buildExchangeCodeBody(code),
            buildExchangeCodeHeader(encodeClientCredentials("wechat", "654321")),
            HttpMethod.POST,
            URI.create(ENDPOINT_TOKEN));
    ResponseEntity<OAuth2Token> response = rest.exchange(request, OAuth2Token.class);
    if (response.getStatusCode().is2xxSuccessful()) {
      return response.getBody();
    }
    throw new RuntimeException("fail to exchange code, code: " + code);
  }
}
