package top.zhongmingmao.blog.clientapp.security;

import lombok.AccessLevel;
import lombok.AllArgsConstructor;
import lombok.experimental.FieldDefaults;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import top.zhongmingmao.blog.clientapp.user.ClientUser;
import top.zhongmingmao.blog.clientapp.user.ClientUserRepository;

import java.util.Optional;

@Service
@AllArgsConstructor
@FieldDefaults(level = AccessLevel.PRIVATE)
public class ClientUserDetailsService implements UserDetailsService {

  ClientUserRepository repository;

  @Override
  public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
    Optional<ClientUser> clientUser = repository.findByUsername(username);
    if (!clientUser.isPresent()) {
      throw new UsernameNotFoundException("invalid username or password");
    }
    return ClientUserDetails.builder().delegator(clientUser.get()).build();
  }
}
